﻿import util.Observer;
import util.Observable;
import logger.Logger;
import logger.LogMessage;

/**
 * Logger類別的觀察者。當影片在Flash製作工具裡的 
 * 影片測試模式之下播放時，這個類別將在輸出面板 
 * 顯示日誌訊息。 
 */
class logger.OutputPanelView implements Observer {
  // 這個物件所觀察的log（對象）。
  private var log:Logger;

  /**
   * 建構子
   */
  public function OutputPanelView (l:Logger) {
    log = l;
  }

  /**
   * 當log改變時，呼叫這個方法。詳細的說明， 
   * 請參閱Observer介面。
   */
  public function update (o:Observable, infoObj:Object):Void {
    // 為了類型檢驗，將infoObj轉換成LogMessage實體。
    var logMsg:LogMessage = LogMessage(infoObj);
    trace(Logger.getLevelDesc(logMsg.getLevel(  )) + ": " + 
                              logMsg.getMessage(  ));
  }

  public function destroy (  ):Void {
    log.removeObserver(this);
  }
}